<kiss-container class="kiss-margin">

    <ul class="kiss-breadcrumbs">
        <li><a href="<?=$this->route('/inbox')?>"><?=t('Inbox')?></a></li>
    </ul>

    <div class="kiss-flex kiss-flex-middle kiss-margin-bottom">
        <div class="kiss-margin-right">
            <kiss-svg class="kiss-margin-auto" src="<?= $this->base(isset($form['icon']) && $form['icon'] ? $form['icon'] : 'inbox:icon.svg') ?>" width="40" height="40" style="color:<?= ($this->escape($form['color'] ?? 'inherit')) ?>"><canvas width="40" height="40"></canvas></kiss-svg>
        </div>

        <div>
            <span class="kiss-text-caption kiss-color-muted"><?=t('Submissions')?></span>
            <div class="kiss-size-5 kiss-text-bold"><?=$this->escape($form['name'])?></div>
        </div>

    </div>

    <vue-view>

        <template>

            <form class="kiss-flex kiss-flex-middle" v-if="((!loading && items.length) || filter)" @submit.prevent="filter = txtFilter">

                <input type="text" class="kiss-input kiss-flex-1 kiss-margin-xsmall-right" :placeholder="t('Filter submissions...')" v-model="txtFilter">

                <div class="kiss-button-group kiss-margin-small-left">
                    <button type="button" class="kiss-button" @click="filter = ''" v-if="filter"><?= t('Reset') ?></button>
                    <button class="kiss-button kiss-flex"><?= t('Search') ?></button>
                </div>
            </form>

            <app-loader class="kiss-margin" v-if="loading"></app-loader>

            <div class="animated fadeIn kiss-height-50vh kiss-flex kiss-flex-middle kiss-flex-center kiss-align-center kiss-color-muted" v-if="!loading && !items.length">
                <div>
                    <kiss-svg class="kiss-margin-auto" src="<?=$this->base('inbox:assets/icons/submissions.svg')?>" width="40" height="40"><canvas width="40" height="40"></canvas></kiss-svg>
                    <p class="kiss-size-large kiss-text-bold kiss-margin-small-top"><?= t('No submissions') ?></p>
                </div>
            </div>

            <div class="table-scroll kiss-margin" ref="tblContainer" v-show="!loading && items.length">
                <table class="kiss-table animated fadeIn" v-if="!loading && items.length">
                    <thead>
                        <tr>
                            <th fixed="left" class="kiss-align-center" width="70">
                                <div class="kiss-flex kiss-flex-middle">
                                    <input class="kiss-checkbox" type="checkbox" @click="toggleAllSelect">
                                    <span class="kiss-margin-small-left">ID</span>
                                </div>
                            </th>
                            <th class="kiss-position-relative">
                                <div class="kiss-flex kiss-flex-middle">
                                    <span><?= t('Data') ?></span>
                                    <span class="kiss-size-6" v-if="sort._state">
                                        <icon>{{sort.data == 1 ? 'south':'north'}}</icon><span>
                                </div>
                                <a class="kiss-cover" @click="sortItems('_state')"></a>
                            </th>
                            <th class="kiss-position-relative" width="120">
                                <div class="kiss-flex kiss-flex-middle">
                                    <span><?= t('Created') ?></span>
                                    <span class="kiss-size-6" v-if="sort._created">
                                        <icon>{{sort._created == 1 ? 'south':'north'}}</icon><span>
                                </div>
                                <a class="kiss-cover" @click="sortItems('_created')"></a>
                            </th>
                            <th fixed="right" width="20"></th>
                        </tr>
                    </thead>
                    <tbody>
                        <tr v-for="item in items">
                            <td fixed="left" class="kiss-align-center">
                                <div class="kiss-flex kiss-flex-middle">
                                    <input class="kiss-checkbox" type="checkbox" v-model="selected" :value="item._id">
                                    <a class="kiss-badge kiss-link-muted kiss-margin-small-left" :title="item._id" @click="showSubmission(item)">...{{ item._id.substr(-5) }}</a>
                                </div>
                            </td>
                            <td class="kiss-position-relative">
                                <div class="kiss-text-truncate kiss-size-small">{{ preview(item) }}</div>
                                <a class="kiss-cover" @click="showSubmission(item)"></a>
                            </td>
                            <td><span class="kiss-flex kiss-badge kiss-badge-outline kiss-color-muted" :title="(new Date(item._created * 1000).toLocaleString())">{{ (new Date(item._created * 1000).toLocaleString()) }}</span></td>
                            <td class="kiss-align-center" fixed="right">
                                <a @click="toggleItemActions(item)">
                                    <icon>more_horiz</icon>
                                </a>
                            </td>
                        </tr>
                    </tbody>
                </table>
            </div>

            <teleport to="body">

                <kiss-popout :open="actionItem && 'true'" @popoutclose="toggleItemActions(null)">
                    <kiss-content>
                        <kiss-navlist v-if="actionItem">
                            <ul>
                                <li class="kiss-nav-header">{{ t('Item actions') }}</li>
                                <li>
                                    <a class="kiss-flex kiss-flex-middle" @click="showSubmission(actionItem)">
                                        <icon class="kiss-margin-small-right">visibility</icon>
                                        <?= t('Show submission') ?>
                                    </a>
                                </li>
                                <li>
                                    <a class="kiss-color-danger kiss-flex kiss-flex-middle" @click="remove(actionItem)">
                                        <icon class="kiss-margin-small-right">delete</icon>
                                        <?= t('Delete') ?>
                                    </a>
                                </li>
                            </ul>
                        </kiss-navlist>
                    </kiss-content>
                </kiss-popout>

            </teleport>

            <app-actionbar>

                <kiss-container>
                    <div class="kiss-flex kiss-flex-middle">
                        <div class="kiss-flex kiss-flex-middle" v-if="!loading && count">
                            <app-pagination>
                                <div class="kiss-color-muted">{{ `${count} ${count == 1 ? t('Item') : t('Items')}` }}</div>
                                <a class="kiss-margin-small-left" v-if="(page - 1) >= 1" @click="load(page - 1)"><?= t('Previous') ?></a>
                                <div class="kiss-margin-small-left kiss-overlay-input" v-if="count > limit">
                                    <strong>{{ page }} &mdash; {{pages}}</strong>
                                    <select v-model="page" @change="load(page)" v-if="pages > 1">
                                        <option v-for="p in pages" :value="p">{{ p }}</option>
                                    </select>
                                </div>
                                <a class="kiss-margin-small-left" v-if="(page + 1) <= pages" @click="load(page + 1)"><?= t('Next') ?></a>
                            </app-pagination>
                        </div>
                        <div class="kiss-flex-1"></div>
                        <div class="kiss-margin-right" v-if="selected.length">
                            <button class="kiss-button kiss-button-danger" @click="removeSelected()">{{ t('Delete') }} -{{ selected.length }}-</button>
                        </div>
                        <a class="kiss-button" href="<?=$this->route("/inbox")?>"><?=t('Close')?></a>
                    </div>
                </kiss-container>

            </app-actionbar>
        </template>

        <script type="module">
            export default {

                data() {

                    return {
                        form: <?=json_encode($form)?>,
                        items: [],
                        selected: [],
                        filter: '',
                        sort: {
                            _created: -1
                        },
                        txtFilter: '',
                        page: 1,
                        pages: 1,
                        limit: 25,
                        count: 0,
                        loading: false,
                        actionItem: null
                    }
                },

                mounted() {

                    let searchParams = new URLSearchParams(location.search);

                    if (searchParams.has('state')) {
                        try {
                            var q = JSON.parse(App.utils.base64decode(searchParams.get('state')));
                            if (q.sort) this.sort = q.sort;
                            if (q.page) this.page = q.page;
                            if (q.limit) this.limit = (parseInt(q.limit) || this.limit);
                            if (q.filter) {
                                this.filter = q.filter;
                                this.txtFilter = q.filter;
                            }
                        } catch (e) {}
                    }

                    this.load(this.page, false);
                },

                watch: {
                    filter(val) {
                        this.txtFilter = val;
                        this.load();
                    }
                },

                methods: {

                    preview(submission) {
                        return JSON.stringify(Object.values(submission.data || {})).replace(/('null'|\[|\]|\{|\}|"|\\|')/g, '').replace(/,/g, ', ').substr(0, 50).trim();
                    },

                    toggleItemActions(item) {

                        if (!item) {
                            setTimeout(() => this.actionItem = null, 300);
                            return;
                        }

                        this.actionItem = item;
                    },

                    toggleAllSelect(e) {

                        this.selected = [];

                        if (e.target.checked) {
                            this.items.forEach(item => this.selected.push(item._id));
                        }
                    },

                    remove(item) {

                        App.ui.confirm('Are you sure?', () => {

                            this.$request(`/inbox/submissions/remove/${this.form._id}`, {
                                ids: [item._id]
                            }).then(res => {
                                this.load(this.page == 1 ? 1 : (this.items.length - 1 ? this.page : this.page - 1));
                                App.ui.notify('Submission removed!');
                            });
                        });
                    },

                    removeSelected() {
                        App.ui.confirm('Are you sure?', () => {

                            this.$request(`/inbox/submissions/remove/${this.form._id}`, {
                                ids: this.selected
                            }).then(res => {
                                this.load(this.page == 1 ? 1 : (this.items.length - this.selected.length ? this.page : this.page - 1));
                                App.ui.notify('Submissions removed!');
                            });
                        });
                    },

                    load(page = 1, history = true) {

                        let options = {
                            limit: this.limit,
                            skip: (page - 1) * this.limit,
                            sort: this.sort
                        };

                        this.loading = true;
                        this.selected = [];

                        if (this.filter) {
                            options.filter = this.filter;
                        }

                        if (history) {

                            window.history.pushState(
                                null, null,
                                App.route(['/inbox/submissions/form/', this.form._id, '?state=', App.utils.base64encode(JSON.stringify({
                                    page: this.page || null,
                                    filter: this.filter || null,
                                    sort: this.sort || null,
                                    limit: this.limit
                                }))].join(''))
                            );
                        }

                        this.$request(`/inbox/submissions/load/${this.form._id}`, {
                            options
                        }).then(rsp => {
                            this.items = rsp.items;
                            this.page = rsp.page;
                            this.pages = rsp.pages;
                            this.count = rsp.count;

                            this.loading = false;
                        })
                    },

                    sortItems(field) {

                        if (this.sort[field]) {
                            this.sort[field] = this.sort[field] == 1 ? -1 : 1;
                        } else {
                            this.sort = {};
                            this.sort[field] = 1;
                        }

                        this.load();
                    },

                    showSubmission(submission) {
                        VueView.ui.offcanvas('inbox:assets/dialogs/submission.js', {submission}, {}, {flip: true, size: 'xlarge'})
                    }
                }
            }
        </script>

    </vue-view>


</kiss-container>
