export default {

    data() {

    },

    components: {
        pagesPage: Vue.defineAsyncComponent(() =>
            App.utils.import('pages:assets/storefront/modules/pages/page.js')
        ),
        pagesMenu: Vue.defineAsyncComponent(() =>
            App.utils.import('pages:assets/storefront/modules/pages/menu.js')
        ),
    },

    props: {
        page: {
            type: Array,
            default: []
        },
        menu: {
            type: Array,
            default: []
        },
    },

    template: /*html*/`
        <div>

            <div class="kiss-size-4 kiss-flex kiss-flex-middle kiss-margin">
                <kiss-svg class="kiss-margin-small-right" :src="$base('pages:icon.svg')" width="30" height="30"><canvas width="30" height="30"></canvas></kiss-svg>
                {{ t('Pages') }}
            </div>

            <div class="kiss-margin" v-if="Array.isArray(page) && page.length">
                <div class="kiss-text-caption kiss-color-muted">{{ t('Page') }}</div>
                <pages-page class="kiss-margin-small" v-for="p in page" :page="p" :key="p._id"></pages-page>
            </div>

            <div class="kiss-margin" v-if="Array.isArray(menu) && menu.length">
                <div class="kiss-text-caption kiss-color-muted">{{ t('Menus') }}</div>
                <pages-menu class="kiss-margin-small" v-for="m in menu" :menu="m"></pages-menu>
            </div>
        </div>
    `
}
