export default {

    data() {
        return {
            data: null
        }
    },

    props: {
        page: {
            type: Object,
            default: null
        }
    },

    mounted() {
        this.load();
    },

    methods: {
        load() {

            this.$request(`/pages/page/${this.page._id}/true`).then((data) => {
                this.data = data;
            }).catch((err) => {
                console.error(err);
            });
        }
    },

    template: /*html*/`
        <kiss-card class="kiss-padding-small" theme="contrast bordered">
            <app-loader size="small" mode="dots" v-if="!data"></app-loader>
            <div class="kiss-size-small" v-if="data">
                <strong>{{ data.page.title }}</strong>
            </div>
        </kiss-card>
    `
}
