<kiss-container class="kiss-margin-large">

    <ul class="kiss-breadcrumbs">
        <li><a href="<?=$this->route('/pages/settings')?>"><?=t('Settings')?></a></li>
    </ul>

    <vue-view class="kiss-margin-large-top">

        <template>

            <kiss-row class="kiss-margin-large" gap="large" :class="{'kiss-disabled': saving}">
                <div class="kiss-flex-1">
                    <div>

                        <app-fieldcontainer class="kiss-margin-large">

                            <label class="kiss-size-5 kiss-flex kiss-flex-middle">
                                <icon class="kiss-size-4 kiss-margin-small-right">saved_search</icon>
                                <span><?=t('SEO')?></span>
                                <icon class="kiss-margin-xsmall-left">language</icon>
                            </label>

                            <div class="kiss-margin" v-for="locale in visibleLocales">

                                <span class="kiss-badge kiss-badge-outline kiss-color-primary" v-if="locales.length > 1">{{ locale.i18n }}</span>

                                <field-seo class="kiss-margin" v-model="settings['seo'+(locale.i18n!='default' ? '_'+locale.i18n:'')]"></field-seo>
                            </div>

                        </app-fieldcontainer>

                        <app-fieldcontainer class="kiss-margin-large">

                            <kiss-tabs>

                                <tab :caption="t('Images')">

                                        <label class="kiss-size-5 kiss-flex kiss-flex-middle">
                                            <icon class="kiss-size-4 kiss-margin-small-right">photo_library</icon>
                                            <?=t('Images')?>
                                        </label>

                                        <kiss-grid class="kiss-margin-small-top" cols="3@m">
                                            <div>
                                                <div class="kiss-size-xsmall kiss-color-muted kiss-margin-small-bottom"><?=t('Logo')?></div>
                                                <field-asset v-model="settings.images.logo"></field-asset>
                                            </div>
                                            <div>
                                                <div class="kiss-size-xsmall kiss-color-muted kiss-margin-small-bottom"><?=t('Small logo')?></div>
                                                <field-asset v-model="settings.images.small"></field-asset>
                                            </div>
                                            <div>
                                                <div class="kiss-size-xsmall kiss-color-muted kiss-margin-small-bottom"><?=t('Favicon')?></div>
                                                <field-asset v-model="settings.images.favicon"></field-asset>
                                            </div>
                                        </kiss-grid>

                                </tab>

                                <tab :caption="t('Scripts')">

                                        <label class="kiss-size-5 kiss-flex kiss-flex-middle">
                                            <icon class="kiss-size-4 kiss-margin-small-right">code</icon>
                                            <?=t('Scripts')?>
                                        </label>

                                        <div class="kiss-margin-small">
                                            <div class="kiss-size-xsmall kiss-color-muted kiss-margin-small-bottom"><?=t('Header')?></div>
                                            <field-code v-model="settings.scripts.header" mode="html" height="150"></field-code>
                                        </div>
                                        <div class="kiss-margin-small">
                                            <div class="kiss-size-xsmall kiss-color-muted kiss-margin-small-bottom"><?=t('Footer')?></div>
                                            <field-code v-model="settings.scripts.footer" mode="html" height="150"></field-code>
                                        </div>

                                </tab>

                                <tab :caption="t('Meta')">

                                        <label class="kiss-size-5 kiss-flex kiss-flex-middle">
                                            <icon class="kiss-size-4 kiss-margin-small-right">scatter_plot</icon>
                                            <?=t('Meta')?>
                                        </label>

                                        <div class="kiss-margin-small">
                                            <field-object v-model="settings.meta"></field-object>
                                        </div>

                                </tab>

                                <tab :caption="t('Preview')">

                                    <kiss-card class="animated fadeIn kiss-padding kiss-align-center kiss-text-caption" theme="contrast" v-if="!settings.preview.length">
                                        <div class="kiss-text-bold"><?=t('No content preview urls defined')?></div>
                                    </kiss-card>

                                    <vue-draggable class="kiss-margin-top" v-model="settings.preview" v-if="settings.preview.length" handle=".fm-handle">
                                        <template #item="{ element }">
                                            <kiss-card class="kiss-flex kiss-flex-middle kiss-margin-small kiss-padding-small" gap="small" theme="bordered contrast">
                                                <a class="fm-handle kiss-color-muted"><icon>drag_handle</icon></a>
                                                <div class="kiss-width-1-4"><input type="text" class="kiss-input kiss-input-small" v-model="element.name" placeholder="<?=t('Name')?>"></div>
                                                <div class="kiss-flex-1"><input type="url" class="kiss-input kiss-input-small" v-model="element.uri" placeholder="https://..."></div>
                                                <a class="kiss-color-danger" @click="settings.preview.splice(settings.preview.indexOf(element), 1)"><icon>delete</icon></a>
                                            </kiss-card>
                                        </template>
                                    </vue-draggable>

                                    <div class="kiss-margin-small">
                                        <button type="button" class="kiss-button kiss-button-small" @click="settings.preview.push({name:'', uri:''})"><icon class="kiss-margin-small-right">control_point</icon> {{ t('Add url') }}</button>
                                    </div>

                                </tab>

                            </kiss-tabs>

                        </app-fieldcontainer>
                    </div>
                </div>
                <div class="kiss-width-1-4@m">

                    <div class="kiss-margin">

                        <div class="kiss-text-caption kiss-size-xsmall kiss-text-bold">{{ t('Translation') }}</div>

                        <kiss-card class="kiss-padding-small kiss-margin-small kiss-text-muted kiss-size-small kiss-color-muted kiss-flex kiss-flex-middle" theme="bordered" v-if="locales.length == 1">
                            <span class="kiss-flex-1 kiss-margin-small-right">{{ t('No locales.') }}</span>
                            <a class="kiss-size-xsmall kiss-text-bolder" href="<?=$this->route('/system/locales')?>">{{ t('Manage') }}</a>
                        </kiss-card>

                        <div class="kiss-margin-small" v-if="locales.length > 1">

                            <kiss-card class="kiss-padding-small kiss-margin-small kiss-text-bolder kiss-flex kiss-flex-middle" :class="{'kiss-color-muted': !loc.visible}" :theme="!loc.visible ? 'bordered':'bordered contrast'" v-for="loc in locales">
                                <div class="kiss-position-relative kiss-flex kiss-flex-middle kiss-flex-1">
                                    <icon class="kiss-margin-small-right" :class="{'kiss-color-primary': loc.visible}">{{ loc.visible ? 'visibility' : 'visibility_off' }}</icon>
                                    <span class="kiss-size-small kiss-flex-1">{{ loc.name }}</span>
                                    <span class="kiss-color-muted kiss-size-xsmall" v-if="loc.i18n == 'default'">{{ t('Default') }}</span>
                                    <a class="kiss-cover" @click="loc.visible = !loc.visible"></a>
                                </div>
                                <a class="kiss-margin-xsmall-left" v-if="loc.i18n != 'default'" @click="settings.locales[loc.i18n] = !settings.locales[loc.i18n]">
                                    <icon :class="{'kiss-color-danger':settings.locales[loc.i18n] === false}">{{settings.locales[loc.i18n] === false ? 'cloud_off': 'cloud'}}</icon>
                                </a>
                            </kiss-card>
                        </div>

                    </div>

                    <div class="kiss-margin">

                        <div class="kiss-text-caption kiss-size-xsmall kiss-text-bold">{{ t('Revisions') }}</div>

                        <kiss-row class="kiss-margin-small kiss-flex-middle">
                            <div class="kiss-size-small kiss-flex-1" :class="{'kiss-color-muted': !settings.revisions}">
                                <?=t('Store every page update as version')?>
                            </div>
                            <field-boolean v-model="settings.revisions"></field-boolean>
                        </kiss-row>

                    </div>

                </div>
            </kiss-row>


            <app-actionbar>

                <kiss-container>
                    <div class="kiss-flex kiss-flex-middle kiss-flex-right">

                        <button class="kiss-button kiss-button-primary" @click="save">
                            <?=t('Save settings')?>
                        </button>
                    </div>
                </kiss-container>

            </app-actionbar>

        </template>

        <script type="module">

            export default {

                data() {
                    return {
                        settings: <?=json_encode($settings)?>,
                        locales: <?=json_encode($locales)?>,
                        saving: false
                    }
                },

                computed: {

                    visibleLocales() {
                        return this.locales.filter(l => l.visible);
                    }
                },

                methods: {

                    save() {

                        this.saving = true;

                        this.$request('/pages/settings/save', {settings: this.settings}).then(settings => {

                            this.saving = false;
                            App.ui.notify('Settings updated!');

                        }).catch(res => {
                            this.saving = false;
                            App.ui.notify(res.error || 'Saving failed!', 'error');
                        });
                    }
                }
            }

        </script>

    </vue-view>

</kiss-container>
