<?php

namespace Webhooks\Helper;

class Webhooks extends \Lime\Helper {

    protected array $hooks = [];

    protected function initialize() {

        $this->hooks = $this->app['debug'] ? $this->cache(false) : $this->app->memory->get('app.webhooks', function() {
            return $this->cache();
        });
    }

    public function hooks() {

        return $this->hooks;
    }

    public function cache(bool $persistent = true): array {

        $cache = [];

        $cache = $this->app->dataStorage->find('webhooks', [])->toArray();

        if ($persistent) {
            $this->app->memory->set('app.webhooks', $cache);
        }

        return $cache;
    }
}